Angular Sortable - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/sortable/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import SortableModule from smart-webcomponents-angular/sortable: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { SortableModule } from 'smart-webcomponents-angular/sortable';

4 Root component (standalone)

Add SortableModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { CheckBoxComponent } from 'smart-webcomponents-angular/checkbox';
import { SortableComponent } from 'smart-webcomponents-angular/sortable';

import { CheckBoxModule } from 'smart-webcomponents-angular/checkbox';import { SortableModule } from 'smart-webcomponents-angular/sortable';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ CheckBoxModule, SortableModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('checkbox', { read: CheckBoxComponent, static: false }) checkbox!: CheckBoxComponent;
    @ViewChild('sortable', { read: SortableComponent, static: false }) sortable!: SortableComponent;


    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.


        const that = this;
        document.getElementById('handle')?.addEventListener('change', function (event: CustomEvent) {
            if (event.detail.value) {
                that.sortable.dragMode = 'handle';
                that.sortable.handleVisibility = 'visible';
            }
            else {
                that.sortable.dragMode = 'item';
            }
        } as EventListener);


    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-sortable as needed:

 <em>Drag and drop to change list order</em>
<smart-sortable #sortable id="sortable"
items="li">
    <ol>
        <li>Strawberries</li>
        <li>Mango</li>
        <li>Watermelon</li>
        <li>Apples</li>
        <li>Bananas</li>
        <li>Grapes</li>
        <li>Pineapples</li>
        <li>Oranges</li>
        <li>Raspberries</li>
        <li>Peaches</li>
        <li>Cherries</li>
        <li>Kiwi</li>
        <li>Blueberries</li>
        <li>Pomegranate</li>
        <li>Lemons</li>
    </ol>
</smart-sortable>
<div class="options">
    <smart-check-box #checkbox id="handle"><code>drag-mode="handle"</code>
    </smart-check-box>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put SortableModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put SortableModule from smart-webcomponents-angular/sortable on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { SortableModule } from 'smart-webcomponents-angular/sortable';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, SortableModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Sortable component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Sortable Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/sortable/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React, { useRef } from "react";
import { CheckBox } from 'smart-webcomponents-react/checkbox';
import { Sortable } from 'smart-webcomponents-react/sortable';

const App = () => {
  const sortableRef = useRef(null);

  const handleChange = (event) => {
    const sortable = sortableRef.current;
    if (!sortable) return;

    if (event.detail.value) {
      sortable.dragMode = 'handle';
      sortable.handleVisibility = 'visible';
    } else {
      sortable.dragMode = 'item';
    }
  };

  return (
    <div>
      <em>Drag and drop to change list order</em>
      <Sortable
        id="sortable"
        items="li"
        ref={sortableRef}
      >
        <ol>
          <li>Strawberries</li>
          <li>Mango</li>
          <li>Watermelon</li>
          <li>Apples</li>
          <li>Bananas</li>
          <li>Grapes</li>
          <li>Pineapples</li>
          <li>Oranges</li>
          <li>Raspberries</li>
          <li>Peaches</li>
          <li>Cherries</li>
          <li>Kiwi</li>
          <li>Blueberries</li>
          <li>Pomegranate</li>
          <li>Lemons</li>
        </ol>
      </Sortable>
      <div className="options">
        <CheckBox onChange={handleChange} id="handle">
          <code>drag-mode="handle"</code>
        </CheckBox>
      </div>
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Sortable, SortableProps } from 'smart-webcomponents-react/sortable';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Sortable component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.